/*

Lecture 25: Multidimensional ArrayLists
August 1, 2019
Sam Vinitsky

Reminders:
- P10 due tonight
- P11 out after class
- Final exam a week from today (!!!)

*/

import java.util.ArrayList;
import java.util.Arrays;

public class ArrayListsLecture2 {
    public static void main (String[] args){

        ///////////////////////
        // REMOVING ELEMENTS //
        ///////////////////////

        // .remove(index)
        // ArrayList<Simple> list = new ArrayList<Simple>();
        // list.add(new Simple(5));
        // list.add(new Simple(10));
        // list.add(new Simple(15));
        // list.add(new Simple(20));
        // // System.out.println(list);
        // // System.out.println(list.size());
        
        // list.remove(1);
        // System.out.println(list);
        // System.out.println(list.size());





        
        // list.remove(0);
        // System.out.println(list);

        // EXAMPLE
        // ArrayList<Simple> list = new ArrayList<Simple>();
        // list.add(new Simple(4));
        // list.add(new Simple(2));
        // list.add(new Simple(0));
        // list.add(new Simple(2));
        // list.add(new Simple(4));
        // System.out.println(list);
        
        // list.remove(1);
        // list.remove(2);
        // System.out.println(list);

        ///////////////////////////
        // TRAVERSING ARRAYLISTS //
        ///////////////////////////

        // EXAMPLE
        // ArrayList<Simple> list = new ArrayList<Simple>();
        // list.add(new Simple(4));
        // list.add(new Simple(2));
        // list.add(new Simple(0));
        // list.add(new Simple(2));
        // list.add(new Simple(4));
        // System.out.println(list);
        
        // for (int i = 0; i < list.size(); i++){
        //     list.get(i).x = 5;
        // }
        // System.out.println(list);

        // EXAMPLE: find the value of x 
        //          for the largest Simple in "list"
        // ArrayList<Simple> list = new ArrayList<Simple>();
        // list.add(new Simple(4));
        // list.add(new Simple(2));
        // list.add(new Simple(10));
        // list.add(new Simple(10));
        // list.add(new Simple(10));
        // list.add(new Simple(-22));
        // list.add(new Simple(123123));

        // int max = list.get(0).x;
        // // write your code here
        // for (int i = 0; i < list.size(); i++){
        //     if (list.get(i).x > max ){
        //         max = list.get(i).x;
        //     }
        // }

        // System.out.println(max);

        // EXAMPLE: clearing a list
        // ArrayList<String> list = new ArrayList<String>();
        // list.add("H");
        // list.add("e");
        // list.add("l");
        // list.add("l");
        // list.add("ooooo");
        // System.out.println(list);
        
        // // write your code here
        // // length = list.size();
        // // for (int i = 0; i < length; i++){
        // //     list.remove(0);
        // // }

        // // while (list.size() != 0){
        // //     list.remove(0);
        // // }

        // // list.clear();

        // System.out.println(list);

        ///////////////////
        // OTHER THINGS? //
        ///////////////////

        // see documentation!
        // (google "ArrayList java 8")

        // arrays VS arraylists


        //////////////////////////////
        // ADVANCED ARRAYLIST IDEAS //
        //////////////////////////////

        // Big Ideas: ArrayLists can store ANY reference type...
        // ArrayList<ArrayList<String>> list = new ArrayList<ArrayList<String>>();
        // list.add(new ArrayList<String>());
        // list.add(new ArrayList<String>());
        // list.add(new ArrayList<String>());
        
        // list.get(0).add("Hello");
        // list.get(1).add("and");
        // list.get(2).add("goodbye!");
        
        // // System.out.println(list);
        // //
        // // // Part 2:
        // list.get(0).add("Sam!");
        // list.get(1).set(0, "Hello Daniel!");
        // list.get(2).add(0, "also, ");
        // //
        // System.out.println(list);
        
        // Can hold arrays...
        // EXAMPLE: what gets printed?
        // ArrayList<int[]> list = new ArrayList<int[]>();
        // list.add(new int[]{2,3,4});
        // list.add(new int[]{5,6,7});
        // list.add(list.get(0));
        
        // System.out.println(list);
        
        // list.get(0)[0] = 5;
        // list.get(1)[2] = 11;
        
        // System.out.println(list);

        // BOTH...
        ArrayList<ArrayList<Simple[]>> fancyList;
        fancyList = new ArrayList<ArrayList<Simple[]>>();
        
        for (int i = 0; i < 3; i++){
            fancyList.add(new ArrayList<Simple[]>());
            for (int j = 1; j <= i+1; j++){
                Simple[] inner = new Simple[j];
                for (int k = 0; k < inner.length; k++){
                    inner[k] = new Simple(i+j+k-1);
                }
                System.out.println(Arrays.toString(inner));
                fancyList.get(i).add(inner);
             
            }
        }
        
        System.out.println(fancyList);
        //
        System.out.println(fancyList.get(0).get(0)[0]);

    }
}